



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android 二维码 生成和识别（附Demo源码）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android 二维码 生成和识别（附Demo源码）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:48:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天讲一下目前移动领域很常用的技术&mdash;&mdash;二维码。现在大街小巷、各大网站都有二维码的踪迹，不管是IOS、 Android、WP都有相关支持的软件。之前我就想了解二维码是如何工作，最近因为工作需要使用相关技术，所以做了初步了解。今天主要是讲解如何使用 ZXing库，生成和识别二维码。这篇文章实用性为主，理论性不会讲解太多，有兴趣可以自己查看源码。</p>
<p><strong>1、ZXing库介绍</strong></p>
<p>　　这里简单介绍一下ZXing库。ZXing是一个开放源码的，用Java实现的多种格式的1D/2D条码图像处理库，它包含了联系到其他语言的端口。Zxing可以实现使用手机的内置的摄像头完成条形码的扫描及解码。该项目可实现的条形码编码和解码。目前支持以下格式：UPC-A，UPC-E、EAN-8，EAN-13、39码、93码。ZXing是个很经典的条码/二维码识别的开源类库，以前在功能机上，就有开发者使用J2ME运用ZXing了，不过要支持JSR-234规范(自动对焦)的手机才能发挥其威力。</p>
<div>　　下面是ZXing的demo运行，我这里创建了一个二维码，内容是我博客的网址，大伙可以用微信的扫一扫功能，试一下。就可以直接打开我博客。</div>
<div><img referrerpolicy="no-referrer"src="http://www.kwstu.com/Content/uploadFiles/images/25213819-1eaa4d41d72c463ab291b40062d0f831.jpg" /></div>
<div>&nbsp;<strong>（PS：新建的QQ群，有兴趣可以加入一起讨论：Android群：322599434）</strong></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><strong>2、ZXing库主要类</strong></div>
<div>
<p>　　下面给大家介绍一下，ZXing库里面主要的类以及这些类的作用：</p>
<ul><li>CaptureActivity。这个是启动Activity 也就是扫描器。</li>
<li>CaptureActivityHandler 解码处理类，负责调用另外的线程进行解码。</li>
<li>DecodeThread 解码的线程。</li>
<li>com.google.zxing.client.android.camera 包，摄像头控制包。</li>
<li>ViewfinderView 自定义的View，就是我们看见的拍摄时中间的框框了。</li></ul>
<p><strong>3、使用ZXing生成二维码</strong></p>
<p>　　下面针对二维码生成和解析做个简单介绍，至于详细的使用方法，建议大家还是自己看看源码，使用起来很简单，不过这个开源项目的代码，值得好好看看。首先给出二维码生成的方法：</p>
<div>
<div>&nbsp;</div>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />
//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums"><strong>　　//要转换的地址或字符串,可以是中文</strong><br />
    public void createQRImage(String url)<br />
    {<br />
        try<br />
        {<br />
            <strong>//判断URL合法性</strong><br />
            if (url == null || "".equals(url) || url.length() &lt; 1)<br />
            {<br />
                return;<br />
            }<br />
            Hashtable&lt;EncodeHintType, String&gt; hints = new Hashtable&lt;EncodeHintType, String&gt;();<br />
            hints.put(EncodeHintType.CHARACTER_SET, "utf-8");<br />
            <strong>//图像数据转换，使用了矩阵转换</strong><br />
            BitMatrix bitMatrix = new QRCodeWriter().encode(url, BarcodeFormat.QR_CODE, QR_WIDTH, QR_HEIGHT, hints);<br />
            int[] pixels = new int[QR_WIDTH * QR_HEIGHT];<br />
            <strong>//下面这里按照二维码的算法，逐个生成二维码的图片，<br />
            //两个for循环是图片横列扫描的结果</strong><br />
            for (int y = 0; y &lt; QR_HEIGHT; y++)<br />
            {<br />
                for (int x = 0; x &lt; QR_WIDTH; x++)<br />
                {<br />
                    if (bitMatrix.get(x, y))<br />
                    {<br />
                        pixels[y * QR_WIDTH + x] = 0xff000000;<br />
                    }<br />
                    else<br />
                    {<br />
                        pixels[y * QR_WIDTH + x] = 0xffffffff;<br />
                    }<br />
                }<br />
            }<br />
            <strong>//生成二维码图片的格式，使用ARGB_8888</strong><br />
            Bitmap bitmap = Bitmap.createBitmap(QR_WIDTH, QR_HEIGHT, Bitmap.Config.ARGB_8888);<br />
            bitmap.setPixels(pixels, 0, QR_WIDTH, 0, 0, QR_WIDTH, QR_HEIGHT);<br />
            <strong>//显示到一个ImageView上面</strong><br />
            sweepIV.setImageBitmap(bitmap);<br />
        }<br />
        catch (WriterException e)<br />
        {<br />
            e.printStackTrace();<br />
        }<br />
    }</pre>
<div>&nbsp;</div>
</div>
<p>　　上面就是二维码生成的方法接口，如果你只是使用者方法，很简单，只要传入一个 URL即可，就像我截图里面一样，传入一个合法的网址即可。或者像现在一些移动APP的推广，把APP下载地址转为二维码，只要扫一下就可以下载相应的 APP。这个也是目前比较流行的APP的推广方式。</p>
<p>　　上面代码做的事情不多，主要是调用ZXing库里面QRCodeWriter().encode的方法对我们传进去的URL进行编码，具体如何编码，这个我这里就不详细说，有兴趣可以看ZXing的源码。文章最后会给出ZXing的源码和例子代码。</p>
<p><strong>4、扫描二维码获取信息</strong></p>
<p>　　扫描获取二维码信息的工作稍微复杂一些，主要是需要编写Camera的使用，这个 跟我们一般使用Camera一样，需要使用Surfaceview作为预览，这一部我这里就不说了，这个应该不是太复杂。对于使用过Camera做预览的 朋友，应该是挺简单的事情。获取二维码数据的关键处理是在Camera的自动对焦回调函数哪里，调用ZXing的解码接口。</p>
<div>
<div>&nbsp;</div>
<pre class="prettyprint linenums">  </pre>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />
//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums">　　private void restartPreviewAndDecode() {<br />
    if (state == State.SUCCESS) {<br />
      state = State.PREVIEW;<br />
      CameraManager.get().requestPreviewFrame(decodeThread.getHandler(), R.id.decode);<br />
      CameraManager.get().requestAutoFocus(this, R.id.auto_focus);<br />
      activity.drawViewfinder();<br />
    }<br />
  }</pre>
<div>&nbsp;</div>
</div>
<p>　　这里稍微多说一句，由于解码需要一定时间，所以ZXing的解码调用，都是使用了Handler作为线程通信机制，解码的工作都是放在独立线程里面使用的，如果你直接在主线程解码，恐怕ANR问题是避免不了。</p>
<div>
<div>&nbsp;</div>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />
//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums">public void handleMessage(Message message) {<br />
    switch (message.what) {<br />
      case R.id.auto_focus:<br />
        //Log.d(TAG, "Got auto-focus message");<br />
        // When one auto focus pass finishes, start another. This is the closest thing to<br />
        // continuous AF. It does seem to hunt a bit, but I'm not sure what else to do.<br />
        if (state == State.PREVIEW) {<br />
          CameraManager.get().requestAutoFocus(this, R.id.auto_focus);<br />
        }<br />
        break;<br />
      case R.id.restart_preview:<br />
        Log.d(TAG, "Got restart preview message");<br />
        restartPreviewAndDecode();<br />
        break;<br />
      case R.id.decode_succeeded:<br />
　　　　<strong>//解码成功，获取到界面的结果和原来的二维码数据</strong><br />
        Log.d(TAG, "Got decode succeeded message");<br />
        state = State.SUCCESS;<br />
        Bundle bundle = message.getData();<br />
        Bitmap barcode = bundle == null ? null :<br />
            (Bitmap) bundle.getParcelable(DecodeThread.BARCODE_BITMAP);<br />
        activity.handleDecode((Result) message.obj, barcode);<br />
        break;<br />
      case R.id.decode_failed:<br />
        // We're decoding as fast as possible, so when one decode fails, start another.<br />
        state = State.PREVIEW;<br />
        CameraManager.get().requestPreviewFrame(decodeThread.getHandler(), R.id.decode);<br />
        break;<br />
      case R.id.return_scan_result:<br />
        Log.d(TAG, "Got return scan result message");<br />
        activity.setResult(Activity.RESULT_OK, (Intent) message.obj);<br />
        activity.finish();<br />
        break;<br />
      case R.id.launch_product_query:<br />
        Log.d(TAG, "Got product query message");<br />
        String url = (String) message.obj;<br />
        Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));<br />
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_WHEN_TASK_RESET);<br />
        activity.startActivity(intent);<br />
        break;<br />
    }<br />
  }</pre>
<div>&nbsp;</div>
</div>
<p>　　上面是解码的线程处理不同状态的时候需要注意的地方，我们这里只看获取图像成功的 地方，成功获取图片解码的实在DecodeThread里面实现，DecodeThread里面解码成功后，会把数据序列化，然后保存到Bundle里 面，我们可以直接通过Bundle的序列化，获取到图片数据。同时会把解码后的结果保存到MSG里面，然后就可以根据实际情况进行处理，例如上面代码，解 码成功后，会调用一个处理函数：</p>
<div>
<div>&nbsp;</div>
<pre class="prettyprint linenums">    </pre>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />
//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums">　　public void handleDecode(final Result obj, Bitmap barcode)<br />
    {<br />
        inactivityTimer.onActivity();<br />
        playBeepSoundAndVibrate();<br />
        AlertDialog.Builder dialog = new AlertDialog.Builder(this);<br />
        if (barcode == null)<br />
        {<br />
            dialog.setIcon(null);<br />
        }<br />
        else<br />
        {

            Drawable drawable = new BitmapDrawable(barcode);<br />
            dialog.setIcon(drawable);<br />
        }<br />
        dialog.setTitle("扫描结果");<br />
        dialog.setMessage(obj.getText());<br />
        dialog.setNegativeButton("确定", new DialogInterface.OnClickListener()<br />
        {<br />
            @Override<br />
            public void onClick(DialogInterface dialog, int which)<br />
            {<br />
                //用默认浏览器打开扫描得到的地址<br />
                Intent intent = new Intent();<br />
                intent.setAction("android.intent.action.VIEW");<br />
                Uri content_url = Uri.parse(obj.getText());<br />
                intent.setData(content_url);<br />
                startActivity(intent);<br />
                finish();<br />
            }<br />
        });<br />
        dialog.setPositiveButton("取消", new DialogInterface.OnClickListener()<br />
        {<br />
            @Override<br />
            public void onClick(DialogInterface dialog, int which)<br />
            {<br />
                finish();<br />
            }<br />
        });<br />
        dialog.create().show();<br />
    }</pre>
<div>&nbsp;</div>
</div>
<p>　　上面就是整个二维码的解码流程，里面因为涉及很多Camera的使用，所以你如果需要使用二维码识别，需要注意一下你的程序需要申请下面的权限，一般的Camera使用以及Camera的自动对焦等。</p>
<div>
<pre class="prettyprint linenums"><strong>//Edited by mythou<br />
//<a href="http://www.cnblogs.com/mythou/" rel="external nofollow noreferrer">http://www.cnblogs.com/mythou/</a></strong></pre>
<pre class="prettyprint linenums">&lt;uses-permission android:name="android.permission.CAMERA"&gt;&lt;/uses-permission&gt;<br />
&lt;uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"&gt;&lt;/uses-permission&gt;<br />
&lt;uses-feature android:name="android.hardware.camera" /&gt;<br />
&lt;uses-feature android:name="android.hardware.camera.autofocus" /&gt;</pre>
</div>
<p><strong>5、结语</strong></p>
<p>　　上面就是生成和识别二维码的关键流程和代码，有兴趣的朋友可以自己查看ZXing 的源码，里面有很多图像分析的知识可以学习。具体使用也可以参考我下面给出的Demo。二维码对于现在移动开发来说很是很常用的技术，所以有空可以了解一 下，说不定什么时候就用上了。另外，ZXing库除了二维码外，其实对于条形码也是支持的，只是我这里没有介绍。有需要的自己去看看源码即可。</p>
<p><strong>2013-8-16</strong></p>
<p><strong>Edited by 泡泡糖</strong></p>
<p><strong>ZXing开源项目Google Code地址：<a href="https://code.google.com/p/zxing/" rel="external nofollow noreferrer">https://code.google.com/p/zxing/</a></strong></p>
<p><strong>ZXingDemo下载：<a href="http://files.cnblogs.com/mythou/ZXingDemo2013-8-25.rar" rel="external nofollow noreferrer">ZXingDemo2013-8-25.rar</a></strong></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4jv30q.html">【面试】shuffle函数的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zjxj39.html">工具 cocoapods和插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z64p1q.html">Eclipse插件收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rlw279.html">TCP&sol;IP网络编程中socket的行为</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1e238.html">UNIX V6内核源码剖析&mdash;&mdash;unix v6 全貌</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6kwn8.html">用C实现字符串分割并返回所有子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13rk28.html">c&plus;&plus;中多态性、dynamic&lowbar;cast、父类指针、父类对象、子类指针、子类对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojl5veq.html">session文件无法并发操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz600l8.html">Python进阶&lowbar;类与实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr0rxq.html">Hibernate系列学习之（二） 多对一、一对一、一对多、多对多的配置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjojl38.html">C语言经典算法 - 多维矩阵转一维矩阵的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvrme8.html">-bash&colon; fork&colon; Cannot allocate memory 问题的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mwlrq.html">C&plus;&plus;学习建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jvd49.html">【转载】Jmeter 性能测试入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25zz4vq.html">Hadoop--单点故障修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvekvjo9.html">Django入门指南-第7章：模板引擎设置（完结）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl2wjz9.html">MP4个人制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4x5nxq.html">DevExpress v15&period;2新功能介绍视频（25集全）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlok64eq.html">OpenCV几种边缘检测的简例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndwv3x8.html">Scrapy框架及组件描述</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1l1548.html">ios7 tableview scrollsToTop 不执行处理方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/390pzjm8.html">自实现CAS原理JAVA版，模拟下单库存扣减</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g52k48.html">OAF&lowbar;开发系列13&lowbar;实现OAF通过Vector动态查询设置（案例）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p3z54q.html">拥抱高效、拥抱 Bugtags 之来自用户的声音 2</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96y6738.html">log4cplus 直接创建logger 对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4keoe9.html">Python 配置日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k20568.html">Codeforces 28C &lbrack;概率DP&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23dno9.html">C&num;接口显示实现在实际开发中的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggmm09.html">在Linux上编写C&num;程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r7gde8.html">StackPanel在增加控件的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
